! Adapted in 17/07/2002 by Alvaro L.Fazenda for version 5.0
! Adapted in 15/04/2003 by Alvaro L.Fazenda for version 5.04
! Adapted in 06/03/2007 by Alvaro L.Fazenda for BRAMS V.4.0
!-------------------------

subroutine CUPARM_GRELL()

  use mem_basic         , only: basic_g

  use mem_tend          , only: tend

  use mem_cuparm        , only: confrq, cuparm_g !,cuparm_g_sh

  use node_mod          , only: &
       mynum, &   ! INTENT(IN)
       mxp,   &   ! INTENT(IN)
       myp,   &   ! INTENT(IN)
       mzp,   &   ! INTENT(IN)
       ia,    &   ! INTENT(IN)
       iz,    &   ! INTENT(IN)
       ja,    &   ! INTENT(IN)
       jz,    &   ! INTENT(IN)
       i0,    &   ! INTENT(IN)  ! Rever funo
       j0         ! INTENT(IN)  ! Rever funo

  ! USE Modules for Grell Parameterization
  use mem_grell_param   , only: &
       mgmxp,   & ! INTENT(IN)
       mgmyp,   & ! INTENT(IN)
       mgmzp,   & ! INTENT(IN)
       maxiens, & ! INTENT(IN)
       ngrids_cp  ! INTENT(IN)

  use mem_scratch1_grell, only: ierr4d,jmin4d,kdet4d,k224d,kbcon4d,ktop4d,kpbl4d, &
       kstabi4d,kstabm4d,xmb4d,edt4d,enup5d,endn5d,deup5d, &
       dedn5d,zup5d,zdn5d, &
       zcup5d,pcup5d,prup5d,clwup5d,tup5d

  use mem_grell         , only: grell_g !,grell_g_sh

  use mem_grid          , only: time,   & ! INTENT(IN)
       initial,                & ! INTENT(IN)
       dtlt,                   & ! INTENT(IN)
       ngrid,                  &
       grid_g,                 &
       naddsc,                 &
       itime1                    ! INTENT(IN)

  use rconstants        , only: tkmin

  use mem_turb          , only: turb_g

  use mem_micro         , only: micro_g

  use mem_scratch       , only: scratch

  use mem_scalar        , only: scalar_g

  implicit none

  integer :: iens = 1

  integer, parameter :: CPTIME = 7200.

  if(iens == 1) then

     if (TIME==0.) then
        call AZERO(mxp*myp*mzp,cuparm_g(ngrid)%THSRC(1,1,1))
        call AZERO(mxp*myp*mzp,cuparm_g(ngrid)%RTSRC(1,1,1))
     end if

     if(INITIAL.eq.2.and.TIME.lt.CPTIME-dtlt) return

     if(mod(TIME,CONFRQ).lt.DTLT.or.time.lt. .01 .or.abs(time-cptime) .lt. 0.01) then

        call AZERO(mxp*myp*mzp,cuparm_g(ngrid)%THSRC(1,1,1))
        call AZERO(mxp*myp*mzp,cuparm_g(ngrid)%RTSRC(1,1,1))
        call AZERO(mxp*myp,cuparm_g(ngrid)%conprr(1,1))

        call CUPARTH(                      &
             mynum,                        & !01
             mgmxp,                        & !02
             mgmyp,                        & !03
             mgmzp,                        & !04
             mzp,                          & !05
             mxp,                          & !06
             myp,                          & !07
             ia,                           & !08
             iz,                           & !09
             ja,                           & !10
             !
             jz,                           & !11
             i0,                           & !12
             j0,                           & !13
             !ibcon,                       & !14
             maxiens,                      & !14
             iens,                         & !15 Lufla
             ngrid,                        & !16
             ngrids_cp,                    & !17
             DTLT,                         & !18
             time,                         & !19
             !
             basic_g(ngrid)%UP(1,1,1),     & !20
             basic_g(ngrid)%VP(1,1,1),     & !21
             basic_g(ngrid)%WP(1,1,1),     & !22
             basic_g(ngrid)%THETA(1,1,1),  & !23
             basic_g(ngrid)%PP(1,1,1),     & !24
             basic_g(ngrid)%PI0(1,1,1),    & !25
             basic_g(ngrid)%DN0(1,1,1),    & !26
             basic_g(ngrid)%RV(1,1,1),     & !27
             grid_g(ngrid)%topt(1,1),      & !28
             !
             grid_g(ngrid)%RTGT(1,1),      & !29
             tend%THT(1),                  & !30
             tend%RTT(1),                  & !31
             !grell_g(ngrid)%lsfth(1,1,1)  ,& !32 Lufla (???) grell_g 3d
             !grell_g(ngrid)%lsfrt(1,1,1)  ,& !33 Lufla (???) grell_g 3d
             tend%PT(1),                   & !32
             cuparm_g(ngrid)%THSRC(1,1,1), & !33 Ver nome para shallow
             cuparm_g(ngrid)%RTSRC(1,1,1), & !34 copiar a estrutura
             cuparm_g(ngrid)%CONPRR(1,1),  & !35
             scratch%scr1(1),              & !36 dummy not in use
             ierr4d,                       & !37
             jmin4d,                       & !38
             kdet4d,                       & !39
             k224d,                        & !40
             kbcon4d,                      & !41
             ktop4d,                       & !42
             kpbl4d,                       & !43
             kstabi4d,                     & !44
             kstabm4d,                     & !45
             xmb4d,                        & !46
             !
             edt4d,                        & !47
             zcup5d,                       & !48 Lufla
             pcup5d,                       & !49 Lufla
             enup5d,                       & !50
             endn5d,                       & !51
             deup5d,                       & !52 Verificar onde
             dedn5d,                       & !53
             zup5d,                        & !54
             zdn5d ,                       & !55
             prup5d,                       & !56 Lufla
             !
             clwup5d,                      & !57 Lufla
             tup5d ,                       & !58 Lufla
             !Insercao de variaveis para salvar nas analises e uso em
             grell_g(ngrid)%upmf(1,1),     & !59 ???? 3d????
             grell_g(ngrid)%dnmf(1,1),     & !60
             grell_g(ngrid)%xierr(1,1),    & !61
             grell_g(ngrid)%xktop(1,1),    & !62
             grell_g(ngrid)%xkbcon(1,1),   & !63
             grell_g(ngrid)%xkbcon(1,1),   & !64 srf- dummy array
             !grell_g(ngrid)%xk22(1,1),     & !65 Lufla
             grell_g(ngrid)%xjmin(1,1),    & !65
             grell_g(ngrid)%xkdt(1,1),     & !66
             !
             grell_g(ngrid)%xiact_p(1,1),  & !67
             grell_g(ngrid)%xiact_c(1,1))    !68
     end if

     call ACCUM(mxp*myp*mzp, tend%tht(1), cuparm_g(ngrid)%THSRC(1,1,1))
     call ACCUM(mxp*myp*mzp, tend%rtt(1), cuparm_g(ngrid)%RTSRC(1,1,1))

     call UPDATE(mxp*myp, cuparm_g(ngrid)%ACONPR(1,1),cuparm_g(ngrid)%CONPRR(1,1),DTLT)

  end if

end subroutine CUPARM_GRELL
